/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.Map;

import org.springframework.cache.annotation.Cacheable;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.JenisPegawai;
import com.portofolio.entity.vo.JenisPegawaiId;

@Lazy
@Repository
public interface JenisPegawaiDao extends CrudRepository<JenisPegawai, JenisPegawaiId> {

	@Query(QListAll)
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,@Param("statusEnabled") boolean statusEnabled, Pageable page);

	@Query(QListAll + " and model.namaJenisPegawai like %:namaJenisPegawai% ")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,@Param("namaJenisPegawai") String namaJenisPegawai, @Param("statusEnabled") boolean statusEnabled,Pageable page);

	@Query(QListAll + " and model.id.kdJenisPegawai = :kdJenisPegawai")
	Map<String, Object> findByKdJenisPegawai(@Param("kdProfile") Integer kdProfile,@Param("kdJenisPegawai") String kdJenisPegawai, @Param("statusEnabled") boolean statusEnabled);

    
    String QListAll ="select new map(model.id.kdJenisPegawai as kdJenisPegawai,model.id.kdProfile as kdProfile "
            + ", model.namaJenisPegawai as namaJenisPegawai " 
            + ", model.reportDisplay as reportDisplay " 
            + ", model.kdKelompokPegawai as kdKelompokPegawai "
            + ", kelompokPegawai.namaKelompokPegawai as namaKelompokPegawai" 
            + ", model.kodeExternal as kodeExternal " 
            + ", model.namaExternal as namaExternal " 
            + ", model.statusEnabled as statusEnabled " 
            + ", model.noRec as noRec " 
            + ", model.version as version )" 
            + " from JenisPegawai model "
            + " left join model.kelompokPegawai kelompokPegawai "
            + " left join model.id id where id.kdProfile=:kdProfile and model.statusEnabled=:statusEnabled "; 

}
